
package org.gjt.bugrat.db;

import java.io.Serializable;
import java.util.Vector;
import java.util.Hashtable;

import org.gjt.bugrat.dbi.*;


public class
BRATProperty extends JartDBObject
	implements Cloneable
	{
	private String		key;
	private String		value;


	public static BRATProperty
	getProperty( String key )
		throws DBIException
		{
		return DBIManager.getInstance().getPropertyDBI().getProperty( key );
		}

	public static Hashtable
	getAllProperties()
		throws DBIException
		{
		return DBIManager.getInstance().getPropertyDBI().getAllProperties();
		}

	public
	BRATProperty( String key, String value )
		{
		this.key = key;
		this.value = value;
		}

	public String
	getKey()
		{
		return this.key;
		}

	public String
	getValue()
		{
		return this.value;
		}

	public void
	setValue( String value )
		{
		this.value = value;
		}

	public void
	commit()
		throws DBIException
		{
		this.getDBI().commit( this );
		this.setModified( false );
		this.setInDatabase( true );
		}

	public Object
	clone()
		{
		BRATProperty bp = (BRATProperty) super.clone();		

		bp.key = new String( this.key );
		bp.value = new String( this.value );

		return bp;
		}

	/**
	 * Returns the currently set BRATPropertyDBI, which is the class
	 * that performs our database needs in a generic fashion.
	 *
	 * @return The ReportDBI subclass that is currently set.
	 * @see ReportDBI
	 */

	private PropertyDBI
	getDBI()
		throws DBIException
		{
		return DBIManager.getInstance().getPropertyDBI();
		}

	public String
	toString()
		{
		return this.value;
		}

	public String
	dumpString()
		{
		return "[" + super.toString()
			+ " key=" + this.key
			+ " value=" + this.value + "]";
		}

	}

