
package org.gjt.bugrat.db;

import java.io.Serializable;
import java.util.Hashtable;

import org.gjt.bugrat.dbi.*;


public
class		Description
extends		JartDBObject
implements	Cloneable
	{
	private int				descId;

	private String			synopsis;
	private int				emailId;
	private EmailMsg		email;
	private String			url;
	private String			mimetype;
	private String			desctext;


	public static Description
	getDescription( int id )
		throws DBIException
		{
		return DBIManager.getInstance().getDescriptionDBI().getDescription( id );
		}

	public static Description
	getNewDescription()
		throws DBIException
		{
		return DBIManager.getInstance().getDescriptionDBI().getNewDescription();
		}

	public static EnvDescription
	getEnvDescription( int id )
		throws DBIException
		{
		return DBIManager.getInstance().getDescriptionDBI().getEnvDescription( id );
		}

	public static EnvDescription
	getNewEnvDescription()
		throws DBIException
		{
		return DBIManager.getInstance().getDescriptionDBI().getNewEnvDescription();
		}

	public static Comment
	getComment( int id )
		throws DBIException
		{
		return DBIManager.getInstance().getDescriptionDBI().getComment( id );
		}

	public static Comment
	getNewComment()
		throws DBIException
		{
		return DBIManager.getInstance().getDescriptionDBI().getNewComment();
		}

	public
	Description( int id )
		{
		this.descId = id;
		}

	public int
	getId()
		{
		return this.descId;
		}

	public String
	getSynopsis()
		{
		return this.synopsis;
		}

	public void
	setSynopsis( String syn )
		{
		this.synopsis = syn;
		}

	public String
	getURL()
		{
		return this.url;
		}

	public void
	setURL( String url )
		{
		this.url = url;
		}

	public EmailMsg
	getEmail()
		{
		return this.email;
		}

	public void
	setEmail( EmailMsg email )
		{
		this.email = email;
		}

	public int
	getEmailId()
		{
		return this.emailId;
		}

	public void
	setEmailId( int emailId )
		{
		this.emailId = emailId;
		}

	public boolean
	hasEmail()
		{
		return (this.emailId > 0);
		}

	public String
	getMimeType()
		{
		return this.mimetype;
		}

	public void
	setMimeType( String mimetype )
		{
		this.mimetype = mimetype;
		}

	public String
	getDescription()
		{
		return this.desctext;
		}

	public void
	setDescription( String desc )
		{
		this.desctext = desc;
		}

	public void
	commit()
		throws DBIException
		{
		this.getDBI().commit( this );
		this.setModified( false );
		this.setInDatabase( true );

		if ( this.email != null )
			{
			this.email.commit();
			}
		}

	public boolean
	equals( Description that )
		{
		if ( that == null )
			return false;

		if ( this.descId != that.descId )
			return false;
		if ( this.emailId != that.emailId )
			return false;

		// UNDONE - the email field...

		if ( ! this.nullEqualStrings( this.synopsis, that.synopsis ) )
			return false;
		if ( ! this.nullEqualStrings( this.url, that.url ) )
			return false;
		if ( ! this.nullEqualStrings( this.mimetype, that.mimetype ) )
			return false;
		if ( ! this.nullEqualStrings( this.desctext, that.desctext ) )
			return false;

		return true;
		}

	public StringBuffer
	getDeltaDescription(
			Description that, String prefix,
			StringBuffer buf, DBConfig cfg )
		{
		if ( that == null )
			{
			buf.append( prefix + "New description:\n" );
			buf.append( prefix + "      EMail ID: " + this.emailId + "\n" );
			buf.append( prefix + "      Synopsis: " + this.synopsis + "\n" );
			buf.append( prefix + "           URL: " + this.url + "\n" );
			buf.append( prefix + "     MIME Type: " + this.mimetype + "\n" );
			buf.append( prefix + "   Description: " + this.desctext + "\n" );
			return buf;
			}

		if ( ! this.nullEqualStrings( this.mimetype, that.mimetype ) )
			{
			buf.append( prefix );
			buf.append( "MIME Type changed from '" );
			buf.append( that.mimetype );
			buf.append( "' to '" );
			buf.append( this.mimetype );
			buf.append( "'.\n" );
			}

		if ( ! this.nullEqualStrings( this.url, that.url ) )
			{
			buf.append( prefix );
			buf.append( "URL changed from:\n" );
			buf.append( prefix );
			buf.append( " > " );
			buf.append( that.url );
			buf.append( "\n" );
			buf.append( prefix );
			buf.append( "To:\n" );
			buf.append( prefix );
			buf.append( " > " );
			buf.append( this.url );
			buf.append( "\n" );
			}

		if ( ! this.nullEqualStrings( this.synopsis, that.synopsis ) )
			{
			buf.append( prefix );
			buf.append( "Synopsis changed from:\n" );
			buf.append( prefix );
			buf.append( " > " );
			buf.append( that.synopsis );
			buf.append( "\n" );
			buf.append( prefix );
			buf.append( "To:\n" );
			buf.append( prefix );
			buf.append( " > " );
			buf.append( this.synopsis );
			buf.append( "\n" );
			}

		if ( ! this.nullEqualStrings( this.desctext, that.desctext ) )
			{
			buf.append( prefix );
			buf.append( "Description changed from:\n" );
			buf.append( prefix );
			buf.append( " > " );
			buf.append( that.desctext );
			buf.append( "\n" );
			buf.append( prefix );
			buf.append( "To:\n" );
			buf.append( prefix );
			buf.append( " > " );
			buf.append( this.desctext );
			buf.append( "\n" );
			}

		return buf;
		}

	public Object
	clone()
		{
		Description desc = (Description) super.clone();		

		desc.descId = this.descId;
		desc.synopsis = this.synopsis;
		desc.url = this.url;
		desc.emailId = this.emailId;
		if ( this.email == null )
			desc.email = null;
		else
			desc.email = (EmailMsg) this.email.clone();
		desc.mimetype = this.mimetype;
		desc.desctext = this.desctext;

		return desc;
		}

	private DescriptionDBI
	getDBI()
		throws DBIException
		{
		return DBIManager.getInstance().getDescriptionDBI();
		}

	public String
	toString()
		{
		return "[" + super.toString()
			+ " descId=" + this.descId + "]";
		}

	}

