
package org.gjt.bugrat.db;

import java.io.*;
import java.util.Date;
import java.util.Hashtable;

import javax.mail.*;
import javax.mail.internet.*;

import org.gjt.bugrat.dbi.*;


public class
EmailContent extends JartDBObject
	implements Cloneable
	{
	private int			emailId;
	private byte[]		content;


	public static EmailContent
	getEmailContent( int id )
		throws DBIException
		{
		return DBIManager.getInstance().getEmailDBI().getEmailContent( id );
		}

	public
	EmailContent( int id )
		{
		this.emailId = id;
		}

	public int
	getId()
		{
		return this.emailId;
		}

	public byte[]
	getContent()
		{
		return this.content;
		}

	public void
	setContent( byte[] content )
		{
		this.content = content;
		}

	public Object
	clone()
		{
		EmailContent cont = (EmailContent) super.clone();		

		cont.emailId = this.emailId;
		cont.content = new byte[ this.content.length ];
		System.arraycopy
			( this.content, 0,
				cont.content, 0,
					this.content.length );

		return cont;
		}

	public void
	commit()
		throws DBIException
		{
		this.getDBI().commitEmailContent( this );
		this.setModified( false );
		this.setInDatabase( true );
		}
/*
	public void
	storeEmailContent( MimeMessage msg )
		throws DBIException
		{
		int id = this.getId();

		try {
			ByteArrayOutputStream os =
				new ByteArrayOutputStream( msg.getSize() );
			msg.writeTo( os );
			byte[] content = os.toByteArray();
			this.getDBI().commit( this );
			}
		catch ( java.io.IOException ex )
			{
			throw new DBIException
				( "IOException: " + ex.getMessage() );
			}
		catch ( MessagingException ex )
			{
			throw new DBIException
				( "MessagingException: " + ex.getMessage() );
			}
		}
*/
	private EmailDBI
	getDBI()
		throws DBIException
		{
		return DBIManager.getInstance().getEmailDBI();
		}

	public String
	toString()
		{
		return "[" + super.toString()
			+ " emailId=" + this.emailId + "]";
		}

	}

