
package org.gjt.bugrat.db;

import java.io.*;
import java.util.Date;
import java.util.Hashtable;

import javax.mail.*;
import javax.mail.internet.*;

import org.gjt.bugrat.dbi.*;


public class
EmailMsg extends JartDBObject
	implements Cloneable
	{
	private int				emailId;
	private Date			recvDate;
	private String			msgId;
	private String			to;
	private String			from;
	private String			subject;
	private EmailContent	content;


	public static EmailMsg
	getEmailMsg( int id )
		throws DBIException
		{
		return DBIManager.getInstance().getEmailDBI().getEmailMsg( id );
		}

	public static EmailMsg
	getEmailMsg( String msgId )
		throws DBIException
		{
		return DBIManager.getInstance().getEmailDBI().getEmailMsg( msgId );
		}

	public static EmailMsg
	getNewEmailMsg()
		throws DBIException
		{
		return DBIManager.getInstance().getEmailDBI().getNewEmailMsg();
		}

	public
	EmailMsg( int id )
		{
		this.emailId = id;
		this.content = null;
		}

	public int
	getId()
		{
		return this.emailId;
		}

	public Date
	getReceiveDate()
		{
		return this.recvDate;
		}

	public void
	setReceiveDate( Date recvDate )
		{
		this.recvDate = recvDate;
		}

	public String
	getMessageID()
		{
		return this.msgId;
		}

	public void
	setMessageID( String msgId )
		{
		this.msgId = msgId;
		}

	public String
	getTo()
		{
		return this.to;
		}

	public void
	setTo( String to )
		{
		this.to = to;
		}

	public String
	getFrom()
		{
		return this.from;
		}

	public void
	setFrom( String from )
		{
		this.from = from;
		}

	public String
	getSubject()
		{
		return this.subject;
		}

	public void
	setSubject( String subject )
		{
		this.subject = subject;
		}

	public EmailContent
	getContent()
		throws DBIException
		{
		if ( this.content == null )
			{
			if ( this.isInDatabase() )
				{
				this.content =
					this.getDBI().getEmailContent
						( this.getId() );
				}
			else
				{
				this.content = new EmailContent( this.getId() );
				this.content.setContent( new byte[0] );
				}
			}

		return this.content;
		}

	public void
	setContent( EmailContent content )
		{
		this.content = content;
		}

	public void
	commit()
		throws DBIException
		{
		this.getDBI().commit( this );
		this.setModified( false );
		this.setInDatabase( true );

		if ( this.content != null )
			{
			content.commit();
			}
		}

	public Object
	clone()
		{
		EmailMsg email = (EmailMsg) super.clone();		

		email.emailId = this.emailId;

		email.recvDate = new Date( this.recvDate.getTime() );
		email.msgId = new String( this.msgId );
		email.to = new String( this.to );
		email.from = new String( this.from );
		email.subject = new String( this.subject );

		return email;
		}

	private EmailDBI
	getDBI()
		throws DBIException
		{
		return DBIManager.getInstance().getEmailDBI();
		}

	public String
	toString()
		{
		return "[" + super.toString()
			+ " emailId=" + this.emailId + "]";
		}

	}

