
package org.gjt.bugrat.db;

import java.io.Serializable;
import java.util.Vector;

import org.gjt.bugrat.dbi.*;


public class
LevelParam extends JartDBObject
	implements Cloneable
	{
	public static final String		PRIORITY_TABLE		= "priority";
	public static final String		SEVERITY_TABLE		= "severity";
	public static final String		CLASS_TABLE			= "class";
	public static final String		CONFIDENCE_TABLE	= "confidence";
	public static final String		STATE_TABLE			= "state";

	private String		table;
	private String		id;
	private String		name;
	private int			level;


	public static LevelParam
	getLevelParam( String table, String id )
		throws DBIException
		{
		LevelParam result =
			DBIManager.getInstance().getLevelParamDBI().
				getLevelParam( table, id );

		return result;
		}

	public static Vector
	getAllLevelParams( String table )
		throws DBIException
		{
		Vector result =
			DBIManager.getInstance().getLevelParamDBI().
				getAllLevelParams( table );

		return result;
		}

	public
	LevelParam( String table, String id )
		{
		this.table = table;
		this.id = id;
		this.name = "";
		this.level = 0;
		}

	public String
	getId()
		{
		return this.id;
		}

	public String
	getTable()
		{
		return this.table;
		}

	public void
	setTable( String table )
		{
		this.table = table;
		}

	public String
	getName()
		{
		return this.name;
		}

	public void
	setName( String name )
		{
		this.name = name;
		}

	public int
	getLevel()
		{
		return this.level;
		}

	public void
	setLevel( int level )
		{
		this.level = level;
		}

	public void
	commit()
		throws DBIException
		{
		this.getDBI().commit( this );
		this.setModified( false );
		this.setInDatabase( true );
		}

	public Object
	clone()
		{
		LevelParam lp = (LevelParam) super.clone();		

		lp.level = this.level;

		lp.id = new String( this.id );
		lp.name = new String( this.name );
		lp.table = new String( this.table );

		return lp;
		}

	/**
	 * Returns the currently set ReportDBI, which is the class that
	 * performs our database needs in a generic fashion.
	 *
	 * @return The ReportDBI subclass that is currently set.
	 * @see ReportDBI
	 */

	private LevelParamDBI
	getDBI()
		{
		LevelParamDBI dbi = null;

		try {
			dbi = DBIManager.getInstance().getLevelParamDBI();
			}
		catch ( DBIException ex )
			{
			ex.printStackTrace( System.err );
			}

		return dbi;
		}

	public String
	toString()
		{
		return this.level + " " + this.name;
		}

	public String
	dumpString()
		{
		return "[" + super.toString()
			+ " id=" + this.id
			+ " table=" + this.table
			+ " name=" + this.name
			+ " level=" + this.level + "]";
		}

	}

