
package org.gjt.bugrat.db;

import java.io.Serializable;
import java.util.Hashtable;

import org.gjt.bugrat.dbi.*;


public
class		Person
extends		JartDBObject
implements	Cloneable, BugRatConstants
	{
	private int			id;
	private String		type;
	private String		name;
	private String		email;
	private String		login;
	private String		org;
	private String		phone;
	private String		fax;
	private String		url;


	public static Person
	getPerson( int id )
		throws DBIException
		{
		return DBIManager.getInstance().getPersonDBI().getPerson( id );
		}

	public static Person
	getPerson( String email )
		throws DBIException
		{
		return DBIManager.getInstance().getPersonDBI().getPerson( email );
		}

	public static Person
	getLoginPerson( String login )
		throws DBIException
		{
		return DBIManager.getInstance().getPersonDBI().getLoginPerson( login );
		}

	public static Person
	getNewPerson( String type, String email, String name )
		throws DBIException
		{
		return DBIManager.getInstance().getPersonDBI().getNewPerson( type, email, name );
		}

	public static Hashtable
	getAllPersons()
		throws DBIException
		{
		Hashtable result =
			DBIManager.getInstance().getPersonDBI().getAllPersons();

		return result;
		}

	public
	Person( int id, String type )
		{
		this.id = id;
		this.type = type;
		this.name = "";
		this.email = "";
		this.org = "";
		this.phone = "";
		this.fax = "";
		this.url = "";
		}

	public int
	getId()
		{
		return this.id;
		}

	public String
	getType()
		{
		return this.type;
		}

	public void
	setType( String type )
		{
		this.type = type;
		}

	public String
	getTypeName()
		{
		if ( this.type.equals( PERSON_ANON ) )
			return "public";
		else if ( this.type.equals( PERSON_USER ) )
			return "bugrat";
		else if ( this.type.equals( PERSON_ADMIN ) )
			return "administrator";
		else
			return "unknown: " + this.type;
		}

	public String
	getName()
		{
		return this.name;
		}

	public void
	setName( String name )
		{
		this.name = name;
		}

	public String
	getEmail()
		{
		return this.email;
		}

	public void
	setEmail( String email )
		{
		this.email = email;
		}

	public String
	getLogin()
		{
		return this.login;
		}

	public void
	setLogin( String login )
		{
		this.login = login;
		}

	public String
	getOrganization()
		{
		return this.org;
		}

	public void
	setOrganization( String org )
		{
		this.org = org;
		}

	public String
	getPhone()
		{
		return this.phone;
		}

	public void
	setPhone( String phone )
		{
		this.phone = phone;
		}

	public String
	getFAX()
		{
		return this.fax;
		}

	public void
	setFAX( String fax )
		{
		this.fax = fax;
		}

	public String
	getURL()
		{
		return this.url;
		}

	public void
	setURL( String url )
		{
		this.url = url;
		}

	public void
	commit()
		throws DBIException
		{
		this.getDBI().commit( this );
		this.setModified( false );
		this.setInDatabase( true );
		}

	public Object
	clone()
		{
		Person per = (Person) super.clone();		

		per.id = this.id;
		per.type = new String( this.type );
		per.name = new String( this.name );
		per.email = new String( this.email );
		per.org = new String( this.org );
		per.phone = new String( this.phone );
		per.fax = new String( this.fax );
		per.url = new String( this.url );

		return per;
		}

	/**
	 * Returns the currently set ReportDBI, which is the class that
	 * performs our database needs in a generic fashion.
	 *
	 * @return The ReportDBI subclass that is currently set.
	 * @see ReportDBI
	 */

	private PersonDBI
	getDBI()
		{
		PersonDBI dbi = null;

		try {
			dbi = DBIManager.getInstance().getPersonDBI();
			}
		catch ( DBIException ex )
			{
			ex.printStackTrace( System.err );
			}

		return dbi;
		}

	public String
	toString()
		{
		return "[" + super.toString()
			+ " id=" + this.id + "]";
		}

	}

