
package org.gjt.bugrat.db;

import java.io.Serializable;
import java.text.FieldPosition;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;
import java.util.Hashtable;

import org.gjt.bugrat.dbi.*;


public
class		Report
extends		JartDBObject
implements	Cloneable, BugRatConstants
	{
	private int				reportId;

	private String			source;
	private int				srcid;
	private Date			submitted;
	private int				submitter;
	private int				responsible;
	private String			confidence;
	private String			severity;
	private String			priority;
	private String			state;
	private String			repclass;
	private String			project;
	private String			category;
	private String			subcat;

	private Description		repdesc;
	private EnvDescription	envdesc;
	private Description		repro;
	private Description		around;


	public static Report
	getNewReport()
		throws DBIException
		{
		return DBIManager.getInstance().getReportDBI().getNewReport();
		}

	public static Report
	getReport( int repId )
		throws DBIException
		{
		return DBIManager.getInstance().getReportDBI().getReport( repId );
		}

	public static Vector
	matchReports( String whereClause )
		throws DBIException
		{
		return DBIManager.getInstance().getReportDBI().matchReports( whereClause );
		}

	public
	Report( int repId )
		{
		this.reportId = repId;
		}

	public int
	getId()
		{
		return this.reportId;
		}

	public String
	getSource()
		{
		return this.source;
		}

	public void
	setSource( String source )
		{
		this.source = source;
		}

	public int
	getSourceId()
		{
		return this.srcid;
		}

	public void
	setSourceId( int id )
		{
		this.srcid = id;
		}

	public String
	getProject()
		{
		return this.project;
		}

	public void
	setProject( String project )
		{
		this.project = project;
		}

	public String
	getCategory()
		{
		return this.category;
		}

	public void
	setCategory( String category )
		{
		this.category = category;
		}

	public String
	getSubCategory()
		{
		return this.subcat;
		}

	public void
	setSubCategory( String subcat )
		{
		this.subcat = subcat;
		}

	public String
	getSeverity()
		{
		return this.severity;
		}

	public void
	setSeverity( String severity )
		{
		this.severity = severity;
		}

	public int
	getResponsible()
		{
		return this.responsible;
		}

	public void
	setResponsible( int responsible )
		{
		this.responsible = responsible;
		}

	public int
	getSubmitter()
		{
		return this.submitter;
		}

	public void
	setSubmitter( int submitter )
		{
		this.submitter = submitter;
		}

	public Date
	getSubmitted()
		{
		return this.submitted;
		}

	public void
	setSubmitted( Date submitted )
		{
		this.submitted = submitted;
		}

	public String
	getReportClass()
		{
		return this.repclass;
		}

	public void
	setReportClass( String cls )
		{
		this.repclass = cls;
		}

	public boolean
	isClosed()
		{
		return this.state.equals( STATE_CLOSED );
		}

	public String
	getState()
		{
		return this.state;
		}

	public void
	setState( String state )
		{
		this.state = state;
		}

	public String
	getPriority()
		{
		return this.priority;
		}

	public void
	setPriority( String priority )
		{
		this.priority = priority;
		}

	public String
	getConfidence()
		{
		return this.confidence;
		}

	public void
	setConfidence( String confidence )
		{
		this.confidence = confidence;
		}

	public Description
	getDescription()
		{
		return this.repdesc;
		}

	public void
	setDescription( Description desc )
		{
		this.repdesc = desc;
		}

	public EnvDescription
	getEnvDescription()
		{
		return this.envdesc;
		}

	public void
	setEnvDescription( EnvDescription desc )
		{
		this.envdesc = desc;
		}

	public Description
	getReproDescription()
		{
		return this.repro;
		}

	public void
	setReproDescription( Description desc )
		{
		this.repro = desc;
		}

	public Description
	getAroundDescription()
		{
		return this.around;
		}

	public void
	setAroundDescription( Description desc )
		{
		this.around = desc;
		}

	public void
	commit()
		throws DBIException
		{
		this.getDBI().commit( this );
		this.setModified( false );
		this.setInDatabase( true );
		}

	public Object
	clone()
		{
		Report rep = (Report) super.clone();		

		rep.reportId = this.reportId;
		// UNDONE

		return rep;
		}

	/**
	 * Returns the currently set ReportDBI, which is the class that
	 * performs our database needs in a generic fashion.
	 *
	 * @return The ReportDBI subclass that is currently set.
	 * @see ReportDBI
	 */

	private ReportDBI
	getDBI()
		throws DBIException
		{
		return DBIManager.getInstance().getReportDBI();
		}

	public String
	toString()
		{
		return "[" + super.toString()
			+ " reportId=" + this.reportId + "]";
		}

	}

