
package org.gjt.bugrat.dbi;

import java.util.Vector;

import org.gjt.bugrat.db.*;
import org.gjt.bugrat.servlet.*;


public
class		ActionJServ
extends		BugRatJServ
implements	ActionDBI
	{
	public
	ActionJServ( String url, String user, String pass )
		{
		super( url, user, pass );
		}

	public BugRatAction
	getAction( int id )
		throws DBIException
		{
		BugRatAction result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "GetAction." + this.requestCounter,
						JSRVConstants.REQ_GET_ACTION );

			request.setParameter
				( JSRVConstants.P_ACTION_ID, new Integer( id ) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (BugRatAction)
					response.getResult( JSRVConstants.P_ACTION );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Vector
	getActions( String target, int targetId )
		throws DBIException
		{
		throw new DBIException( "--UNIMPLEMENTED--" );
		}

	public BugRatAction
	getNewAction( String type )
		throws DBIException
		{
		BugRatAction result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "NewAction." + this.requestCounter,
						JSRVConstants.REQ_GET_NEW_ACTION );

			request.setParameter
				( JSRVConstants.P_ACTION_TYPE, type );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (BugRatAction)
					response.getResult( JSRVConstants.P_ACTION );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public void
	commit( BugRatAction act )
		throws DBIException
		{
		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "CommitAction." + this.requestCounter,
						JSRVConstants.REQ_COMMIT_ACTION );

			request.setParameter
				( JSRVConstants.P_ACTION, act );

			JSRVConnection conn =
				new JSRVConnection( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				act.setModified( false );
				act.setInDatabase( true );
				}
			else
				{
				throw new JSRVException
					( "commit action failed err="
						+ response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "JServlet error: " + ex.getMessage() );
			}
		}

	}

