
package org.gjt.bugrat.dbi;

import java.util.Vector;
import java.util.Hashtable;

import org.gjt.bugrat.db.*;
import org.gjt.bugrat.servlet.*;


public class
BugJServ extends BugRatJServ
	implements BugDBI
	{
	public
	BugJServ( String url, String user, String pass )
		{
		super( url, user, pass );
		}

	public Bug
	getBug( int bugId )
		throws DBIException
		{
		Bug result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Bug" + this.requestCounter,
						JSRVConstants.REQ_GET_BUG );

			request.setParameter
				( JSRVConstants.P_BUG_ID, new Integer(bugId) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Bug)
					response.getResult
						( JSRVConstants.P_BUG );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRatServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Bug
	getNewBug()
		throws DBIException
		{
		Bug result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Bug" + this.requestCounter,
						JSRVConstants.REQ_GET_NEW_BUG );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Bug)
					response.getResult
						( JSRVConstants.P_BUG );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRatServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Vector
	getAllBugs()
		throws DBIException
		{
		return this.matchBugs( "" );
		}

	public Vector
	matchBugs( String selectStr )
		throws DBIException
		{
		Vector result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "BugMatch" + this.requestCounter,
						JSRVConstants.REQ_MATCH_BUGS );

			request.setParameter
				( JSRVConstants.P_MATCH_EXPR, selectStr );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Vector)
					response.getResult
						( JSRVConstants.P_BUG_VECTOR );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRatServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public void
	commit( Bug bug )
		throws DBIException
		{
	/* **** UNDONE
		try {
			this.requestCounter++;

			CSAPIRequest request =
				new CSAPIRequest
					( "CSAPI" + this.requestCounter,
						CSAPIConstants.REQ_COMMIT_ACCOUNT );

			request.setParameter
					( CSAPIConstants.P_ACCOUNT, acct );

			CSAPIConnection conn =
				new CSAPIConnection( this.urlCSAPI, this.user, this.pass );

			CSAPIResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				acct.setInDatabase( true );
				acct.setModified( false );
				}
			else
				{
				throw new CSAPIException
					( "commit failed err=" + response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( CSAPIException ex )
			{
			throw new CustDBIException
				( "CSAPI error: " + ex.getMessage() );
			}
	***** */
		}

	}

