
package org.gjt.bugrat.dbi;

import java.sql.*;
import java.util.Vector;
import org.gjt.bugrat.db.*;


public class
CategoryJDBC extends BugRatJDBC
	implements CategoryDBI
	{
	private static final boolean	DEBUG = false;

	public
	CategoryJDBC( JDBCHandler handler )
		{
		super( handler );
		}

	public Category
	getCategory( String pkg, String cat, String sub )
		throws DBIException
		{
		Category result = null;
		String queryStr = null;

		try {
			queryStr = 
				"SELECT" +
				"   category.resp," +
				"   category.name," +
				"   category.catdesc " +
				"FROM category " +
				"WHERE category.pkg = '" + pkg + "'" +
				"  AND category.cat = '" + cat + "'" +
				"  AND category.sub = '" + sub + "'";

			Statement stmt =
				this.handler.createStatement();

			ResultSet rs = stmt.executeQuery( queryStr );

			if ( rs.next() )
				{
				result = new Category( pkg, cat, sub );

				result.setModified( false );
				result.setInDatabase( true );

				int col = 1;
				result.setResponsible( rs.getInt( col++ ) );
				result.setName( rs.getString( col++ ) );
				result.setDescription( this.getString( rs, col++ ) );
				}

			rs.close();
			stmt.close();
			}
		catch ( SQLException ex )
			{
			if ( DEBUG )
				ex.printStackTrace( System.err );
			throw new DBIException
				( ex, "statement '" + queryStr + "'" );
			}

		return result;
		}

	public Vector
	getAllCategories()
		throws DBIException
		{
		Vector result = new Vector();
		String queryStr = null;

		try {
			queryStr = 
				"SELECT" +
				"   category.pkg," +
				"   category.cat," +
				"   category.sub," +
				"   category.resp," +
				"   category.name," +
				"   category.catdesc " +
				"FROM category";

			Statement stmt =
				this.handler.createStatement();

			ResultSet rs = stmt.executeQuery( queryStr );

			for ( ; rs.next() ; )
				{
				int col = 1;
				String pkg = rs.getString( col++ );
				String cat = rs.getString( col++ );
				String sub = rs.getString( col++ );

				Category c = new Category( pkg, cat, sub );

				c.setModified( false );
				c.setInDatabase( true );

				c.setResponsible( rs.getInt( col++ ) );

				c.setName( rs.getString( col++ ) );
				c.setDescription( this.getString( rs, col++ ) );
				
				result.addElement( c );
				}

			rs.close();

			stmt.close();
			}
		catch ( SQLException ex )
			{
			if ( DEBUG )
				ex.printStackTrace( System.err );
			throw new DBIException
				( ex, "statement '" + queryStr + "'" );
			}

		return result;
		}

	public void
	commit( Category cat )
		throws DBIException
		{
		String pkgStr = cat.getProject();
		String catStr = cat.getCategory();
		String subStr = cat.getSubCategory();

		try {
			StringBuffer buf = new StringBuffer();

			if ( cat.isInDatabase() )
				{
				buf.append( "UPDATE category " );
				buf.append( "SET " );
				buf.append( "  category.resp = ?," );
				buf.append( "  category.name = ?," );
				buf.append( "  category.catdesc = ? " );
				buf.append( "WHERE category.pkg = '" + pkgStr + "' " );
				buf.append( "  AND category.cat = '" + catStr + "' " );
				buf.append( "  AND category.sub = '" + subStr + "' " );
				}
			else
				{
				buf.append( "INSERT INTO category" );
				buf.append( "  ( category.pkg, category.cat, category.sub," );
				buf.append( "    category.resp, category.name, category.catdesc ) " );
				buf.append( "VALUES" );
				buf.append( "  ( ?, ?, ?, ?, ?, ? ) " );
				}

			if ( DEBUG )
				System.err.println
					( "CategoryJDBC.commit: isInDatabase = '"
						+ cat.isInDatabase() + "'  Cmd = '"
						+ buf.toString() + "'" );

			PreparedStatement pS =
				this.handler.createPreparedStatement( buf.toString() );

			int pidx = 1;
			if ( ! cat.isInDatabase() )
				{
				pS.setString( pidx++, pkgStr );
				pS.setString( pidx++, catStr );
				pS.setString( pidx++, subStr );
				}

			pS.setInt( pidx++, cat.getResponsible() );
			pS.setString( pidx++, cat.getName() );
			this.setNullString
				( pS, pidx++, cat.getDescription(), java.sql.Types.CHAR );

			int rows = pS.executeUpdate();
			
			pS.close();

			if ( DEBUG )
				System.err.println
					( "CategoryJDBC.commit: rows = '" + rows + "'" );
			}
		catch ( SQLException ex )
			{
			if ( DEBUG )
				ex.printStackTrace( System.err );
			throw new DBIException
				( ex, "committing category '"
					+pkgStr+ "," +catStr+ "," +subStr+ "'" );
			}
		}

	}


