
package org.gjt.bugrat.dbi;

import java.util.Hashtable;
import java.util.Vector;

import org.gjt.bugrat.db.*;
import org.gjt.bugrat.servlet.*;


public class
DescriptionJServ extends BugRatJServ
	implements DescriptionDBI
	{
	public
	DescriptionJServ( String url, String user, String pass )
		{
		super( url, user, pass );
		}

	public Description
	getDescription( int descId )
		throws DBIException
		{
		Description result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_DESCRIPTION );

			request.setParameter
				( JSRVConstants.P_DESCRIPTION_ID,
					new Integer( descId ) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Description)
					response.getResult
						( JSRVConstants.P_DESCRIPTION );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Description
	getNewDescription( )
		throws DBIException
		{
		Description result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_NEW_DESCRIPTION );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				result = (Description)
					response.getResult( JSRVConstants.P_DESCRIPTION );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRat DBIServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public EnvDescription
	getEnvDescription( int descId )
		throws DBIException
		{
		EnvDescription result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_ENVDESC );

			request.setParameter
				( JSRVConstants.P_ENVDESC_ID,
					new Integer( descId ) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				result = (EnvDescription)
					response.getResult( JSRVConstants.P_ENVDESC );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public EnvDescription
	getNewEnvDescription( )
		throws DBIException
		{
		EnvDescription result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_NEW_ENVDESC );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				result = (EnvDescription)
					response.getResult( JSRVConstants.P_ENVDESC );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRat DBIServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Comment
	getComment( int descId )
		throws DBIException
		{
		Comment result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_COMMENT );

			request.setParameter
				( JSRVConstants.P_COMMENT_ID,
					new Integer( descId ) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				result = (Comment)
					response.getResult( JSRVConstants.P_COMMENT );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Comment
	getNewComment( )
		throws DBIException
		{
		Comment result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_NEW_COMMENT );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				result = (Comment)
					response.getResult( JSRVConstants.P_COMMENT );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRat DBIServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Vector
	getComments( String target, int targetId )
		throws DBIException
		{
		throw new DBIException( "UNIMPLEMENTED" );
		}

	public void
	commit( Description desc )
		throws DBIException
		{
		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "CommitPerson" + this.requestCounter,
						JSRVConstants.REQ_COMMIT_DESCRIPTION );

			request.setParameter
					( JSRVConstants.P_DESCRIPTION, desc );

			JSRVConnection conn =
				new JSRVConnection( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				desc.setModified( false );
				desc.setInDatabase( true );
				}
			else
				{
				throw new JSRVException
					( "commit description failed err="
						+ response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "JServlet error: " + ex.getMessage() );
			}
		}

	public void
	commit( EnvDescription desc )
		throws DBIException
		{
		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "CommitPerson" + this.requestCounter,
						JSRVConstants.REQ_COMMIT_ENVDESC );

			request.setParameter
					( JSRVConstants.P_ENVDESC, desc );

			JSRVConnection conn =
				new JSRVConnection( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				desc.setModified( false );
				desc.setInDatabase( true );
				}
			else
				{
				throw new JSRVException
					( "commit envdesc failed err="
						+ response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "JServlet error: " + ex.getMessage() );
			}
		}

	public void
	commit( Comment cmt )
		throws DBIException
		{
		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "CommitPerson" + this.requestCounter,
						JSRVConstants.REQ_COMMIT_COMMENT );

			request.setParameter
					( JSRVConstants.P_COMMENT, cmt );

			JSRVConnection conn =
				new JSRVConnection( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				cmt.setModified( false );
				cmt.setInDatabase( true );
				}
			else
				{
				throw new JSRVException
					( "commit comment failed err="
						+ response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "JServlet error: " + ex.getMessage() );
			}
		}

	}

