
package org.gjt.bugrat.dbi;

import java.util.Hashtable;

import org.gjt.bugrat.db.*;
import org.gjt.bugrat.servlet.*;


public class
EmailJServ extends BugRatJServ
	implements EmailDBI
	{
	public
	EmailJServ( String url, String user, String pass )
		{
		super( url, user, pass );
		}

	public EmailMsg
	getEmailMsg( int msgId )
		throws DBIException
		{
		EmailMsg result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "EmailJServ." + this.requestCounter,
						JSRVConstants.REQ_GET_EMAIL );

			request.setParameter
				( JSRVConstants.P_EMAIL_ID, new Integer(msgId) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (EmailMsg)
					response.getResult
						( JSRVConstants.P_EMAIL );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRatServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public EmailMsg
	getEmailMsg( String msgId )
		throws DBIException
		{
		EmailMsg result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "EmailJServ." + this.requestCounter,
						JSRVConstants.REQ_GET_EMAIL_MSGID );

			request.setParameter
				( JSRVConstants.P_EMAIL_MSGID, new Integer(msgId) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (EmailMsg)
					response.getResult
						( JSRVConstants.P_EMAIL );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRatServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public EmailMsg
	getNewEmailMsg()
		throws DBIException
		{
		EmailMsg result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "EmailJServ." + this.requestCounter,
						JSRVConstants.REQ_GET_NEW_EMAIL );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (EmailMsg)
					response.getResult
						( JSRVConstants.P_EMAIL );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRatServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public void
	commit( EmailMsg msg )
		throws DBIException
		{
		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "CommitPerson" + this.requestCounter,
						JSRVConstants.REQ_COMMIT_EMAIL );

			request.setParameter
					( JSRVConstants.P_EMAIL, msg );

			JSRVConnection conn =
				new JSRVConnection( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				msg.setModified( false );
				msg.setInDatabase( true );
				}
			else
				{
				throw new JSRVException
					( "commit email msg failed err="
						+ response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRatServlet error: " + ex.getMessage() );
			}
		}

	public EmailContent
	getEmailContent( int msgId )
		throws DBIException
		{
		EmailContent result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "EmailJServ." + this.requestCounter,
						JSRVConstants.REQ_GET_EMAIL_CONTENT );

			request.setParameter
				( JSRVConstants.P_EMAIL_ID, new Integer(msgId) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (EmailContent)
					response.getResult
						( JSRVConstants.P_EMAIL_CONTENT );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRatServlet error: " + ex.getMessage() );
			}

		return result;
		}

	public void
	commitEmailContent( EmailContent cont )
		throws DBIException
		{
		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "CommitPerson" + this.requestCounter,
						JSRVConstants.REQ_COMMIT_EMAIL_CONTENT );

			request.setParameter
					( JSRVConstants.P_EMAIL_CONTENT, cont );

			JSRVConnection conn =
				new JSRVConnection( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( ! response.getSuccess() )
				{
				throw new JSRVException
					( "commit email content failed err="
						+ response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRatServlet error: " + ex.getMessage() );
			}
		}

	}

