
package org.gjt.bugrat.dbi;

import java.sql.*;
import java.util.Vector;
import org.gjt.bugrat.db.*;


public class
LevelParamJDBC extends BugRatJDBC
	implements LevelParamDBI
	{
	private static final boolean	DEBUG = false;

	public
	LevelParamJDBC( JDBCHandler handler )
		{
		super( handler );
		}

	public LevelParam
	getLevelParam( String table, String id )
		throws DBIException
		{
		LevelParam result = null;
		String queryStr = null;

		try {
			queryStr = 
				"SELECT" +
				"   name," +
				"   lvl, " +
				"   info " +
				"FROM " + table + " " +
				"WHERE id = '" + id + "'";

			Statement stmt = this.handler.createStatement();
			ResultSet rs = stmt.executeQuery( queryStr );

			if ( rs.next() )
				{
				int col = 1;
				result = new LevelParam( table, id );

				result.setModified( false );
				result.setInDatabase( true );

				result.setName( rs.getString( col++ ) );
				result.setLevel( rs.getInt( col++ ) );
				}

			rs.close();
			stmt.close();
			}
		catch ( SQLException ex )
			{
			if ( DEBUG )
				ex.printStackTrace( System.err );
			throw new DBIException
				( ex, "statement '" + queryStr + "'" );
			}

		return result;
		}

	public Vector
	getAllLevelParams( String table )
		throws DBIException
		{
		Vector result = new Vector();
		String queryStr = null;

		try {
			queryStr = 
				"SELECT" +
				"   id," +
				"   name," +
				"   lvl, " +
				"   info " +
				"FROM " + table;

			if ( DEBUG )
				System.err.println
					( "LevelParamJDBC.getAllLevelParams: query = '"
						+ queryStr + "'" );

			Statement stmt = this.handler.createStatement();
			ResultSet rs = stmt.executeQuery( queryStr );

			for ( ; rs.next() ; )
				{
				int col = 1;
				String id = rs.getString( col++ );
				LevelParam lp = new LevelParam( table, id );

				lp.setModified( false );
				lp.setInDatabase( true );
				lp.setName( rs.getString( col++ ) );
				lp.setLevel( rs.getInt( col++ ) );
				
				result.addElement( lp );
				}

			rs.close();
			stmt.close();
			}
		catch ( SQLException ex )
			{
			if ( DEBUG )
				ex.printStackTrace( System.err );
			throw new DBIException
				( ex, "statement '" + queryStr + "'" );
			}

		return result;
		}

	public void
	commit( LevelParam lp )
		throws DBIException
		{
		String id = lp.getId();
		String table = lp.getTable();

		try {
			StringBuffer buf = new StringBuffer();

			if ( lp.isInDatabase() )
				{
				buf.append( "UPDATE " );
				buf.append( table );
				buf.append( " " );
				buf.append( "SET " );
				buf.append( "name = '" );
				buf.append(    lp.getName() );
				buf.append(    "', " );
				buf.append( "level = '" );
				buf.append(    lp.getLevel() );
				buf.append(    "', " );
				buf.append( "info = null " );
				buf.append( "WHERE id = '" + id + "' " );
				}
			else
				{
				buf.append( "INSERT INTO " );
				buf.append( table );
				buf.append( " " );
				buf.append( "( " );
				buf.append( " id, name, level, info " );
				buf.append( ") " );
				buf.append( "VALUES " );
				buf.append( "( " );
				buf.append( "'" + id + "', " );
				buf.append( "'" + lp.getName() + "', " );
				buf.append( "'" + lp.getLevel() + "', " );
				buf.append( "null " );
				buf.append( ") " );
				}

			if ( DEBUG )
				System.err.println
					( "LevelParamJDBC.commit: isInDatabase = '"
						+ lp.isInDatabase() + "'  Cmd = '"
						+ buf.toString() + "'" );

			Statement stmt = this.handler.createStatement();

			int rows = stmt.executeUpdate( buf.toString() );
			
			stmt.close();

			if ( DEBUG )
				System.err.println
					( "LevelParamJDBC.commit: rows = '" + rows + "'" );
			}
		catch ( SQLException ex )
			{
			if ( DEBUG )
				ex.printStackTrace( System.err );
			throw new DBIException
				( ex, "committing level param '" + table + "/" + id + "'" );
			}
		}

	}


