
package org.gjt.bugrat.dbi;

import java.util.Vector;

import org.gjt.bugrat.db.*;
import org.gjt.bugrat.servlet.*;


public class
LevelParamJServ extends BugRatJServ
	implements LevelParamDBI
	{
	public
	LevelParamJServ( String url, String user, String pass )
		{
		super( url, user, pass );
		}

	public LevelParam
	getLevelParam( String table, String id )
		throws DBIException
		{
		LevelParam result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_LEVELPARAM );

			request.setParameter
				( JSRVConstants.P_LEVEL_TABLE_ID, table );

			request.setParameter
				( JSRVConstants.P_LEVEL_PARAM_ID, id );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (LevelParam)
					response.getResult
						( JSRVConstants.P_LEVEL_PARAM );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Vector
	getAllLevelParams( String table )
		throws DBIException
		{
		Vector result = new Vector();

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_ALLLEVELPARAMS );

			request.setParameter
				( JSRVConstants.P_LEVEL_TABLE_ID, table );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Vector)
					response.getResult
						( JSRVConstants.P_LEVEL_PARAM_VECTOR );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public void
	commit( LevelParam lp )
		throws DBIException
		{
		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "CommitLevelParam" + this.requestCounter,
						JSRVConstants.REQ_COMMIT_LEVELPARAM );

			request.setParameter
				( JSRVConstants.P_LEVEL_PARAM, lp );

			JSRVConnection conn =
				new JSRVConnection( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				lp.setModified( false );
				lp.setInDatabase( true );
				}
			else
				{
				throw new JSRVException
					( "commit level parameter failed err="
						+ response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "JServlet error: " + ex.getMessage() );
			}
		}

	}

