
package org.gjt.bugrat.dbi;

import java.util.Hashtable;

import org.gjt.bugrat.db.*;
import org.gjt.bugrat.servlet.*;


public class
PersonJServ extends BugRatJServ
	implements PersonDBI
	{
	public
	PersonJServ( String url, String user, String pass )
		{
		super( url, user, pass );
		}

	public Person
	getPerson( int personId )
		throws DBIException
		{
		Person result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_PERSON );

			request.setParameter
				( JSRVConstants.P_PERSON_ID, new Integer(personId) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Person)
					response.getResult
						( JSRVConstants.P_PERSON );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Person
	getPerson( String email )
		throws DBIException
		{
		Person result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_PERSON_BY_EMAIL );

			request.setParameter
				( JSRVConstants.P_PERSON_EMAIL, email );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Person)
					response.getResult
						( JSRVConstants.P_PERSON );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Person
	getLoginPerson( String login )
		throws DBIException
		{
		throw new DBIException( "--UNIMPLEMENTED--" );
		}

	public Person
	getNewPerson( String type, String email, String name )
		throws DBIException
		{
		Person result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_NEW_PERSON );

			request.setParameter
				( JSRVConstants.P_PERSON_TYPE, type );
			request.setParameter
				( JSRVConstants.P_PERSON_EMAIL, email );
			request.setParameter
				( JSRVConstants.P_PERSON_NAME, name );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Person)
					response.getResult
						( JSRVConstants.P_PERSON );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Hashtable
	getAllPersons()
		throws DBIException
		{
		Hashtable result = new Hashtable();

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_ALLPERSONS );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Hashtable)
					response.getResult
						( JSRVConstants.P_PERSON_HASHTABLE );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public void
	commit( Person per )
		throws DBIException
		{
		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "CommitPerson" + this.requestCounter,
						JSRVConstants.REQ_COMMIT_PERSON );

			request.setParameter
					( JSRVConstants.P_PERSON, per );

			JSRVConnection conn =
				new JSRVConnection( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				per.setModified( false );
				per.setInDatabase( true );
				}
			else
				{
				throw new JSRVException
					( "commit person failed err=" + response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "JServlet error: " + ex.getMessage() );
			}
		}

	}

