
package org.gjt.bugrat.dbi;

import java.sql.*;
import java.util.Vector;
import java.util.Hashtable;

import org.gjt.bugrat.db.*;


public class
PropertyJDBC extends BugRatJDBC
	implements PropertyDBI
	{
	private static final boolean	DEBUG = false;

	public
	PropertyJDBC( JDBCHandler handler )
		{
		super( handler );
		}

	public BRATProperty
	getProperty( String key )
		throws DBIException
		{
		BRATProperty result = null;
		String queryStr = null;

		try {
			queryStr = 
				"SELECT" +
				"   propval " +
				"FROM properties " +
				"WHERE propkey = '" + key + "'";

			Statement stmt = this.handler.createStatement();
			ResultSet rs = stmt.executeQuery( queryStr );

			if ( rs.next() )
				{
				int col = 1;
				result =
					new BRATProperty
						( key, this.getLargeString( rs, col++ ) );

				result.setModified( false );
				result.setInDatabase( true );
				}

			rs.close();
			stmt.close();
			}
		catch ( SQLException ex )
			{
			if ( DEBUG )
				ex.printStackTrace( System.err );
			throw new DBIException
				( ex, "statement '" + queryStr + "'" );
			}

		return result;
		}

	public Hashtable
	getAllProperties()
		throws DBIException
		{
		Hashtable result = new Hashtable();
		String queryStr = null;

		try {
			queryStr = 
				"SELECT" +
				"   propkey," +
				"   propval " +
				"FROM properties";

			Statement stmt = this.handler.createStatement();
			ResultSet rs = stmt.executeQuery( queryStr );

			for ( ; rs.next() ; )
				{
				int col = 1;
				String key = rs.getString( col++ );
				String value = this.getLargeString( rs, col++ );

				BRATProperty bp = new BRATProperty( key, value );
				bp.setModified( false );
				bp.setInDatabase( true );
				
				result.put( key, bp );
				}

			rs.close();
			stmt.close();
			}
		catch ( SQLException ex )
			{
			if ( DEBUG )
				ex.printStackTrace( System.err );
			throw new DBIException
				( ex, "statement '" + queryStr + "'" );
			}

		return result;
		}

	public void
	commit( BRATProperty bp )
		throws DBIException
		{
		try {
			StringBuffer buf = new StringBuffer();

			if ( bp.isInDatabase() )
				{
				buf.append( "UPDATE properties " );
				buf.append( "SET" );
				buf.append( "  propval = ? " );
				buf.append( "WHERE" );
				buf.append( "  propkey = '" );
				buf.append( bp.getKey() );
				buf.append( "' " );
				}
			else
				{
				buf.append( "INSERT INTO properties " );
				buf.append( " ( propkey, propval ) " );
				buf.append( "VALUES " );
				buf.append( " ( ?, ? ) " );
				}

			if ( DEBUG )
				System.err.println
					( "PropertyJDBC.commit: isInDatabase = '"
						+ bp.isInDatabase() + "'  Cmd = '"
						+ buf.toString() + "'" );

			PreparedStatement pS =
				this.handler.createPreparedStatement
					( buf.toString() );

			int pidx = 1;
			if ( ! bp.isInDatabase() )
				{
				pS.setString( pidx++, bp.getKey() );
				}

			this.setLargeString
				( pS, pidx++, bp.getValue(), java.sql.Types.CHAR );

			int rows = pS.executeUpdate();
			
			pS.close();

			if ( DEBUG )
				System.err.println
					( "PropertyJDBC.commit: rows = '" + rows + "'" );
			}
		catch ( SQLException ex )
			{
			if ( DEBUG )
				ex.printStackTrace( System.err );
			throw new DBIException
				( ex, "committing property ["
					+ bp.getKey() + "] " );
			}
		}

	}


