
package org.gjt.bugrat.dbi;

import java.util.Vector;
import java.util.Hashtable;

import org.gjt.bugrat.db.*;
import org.gjt.bugrat.servlet.*;


public class
PropertyJServ extends BugRatJServ
	implements PropertyDBI
	{
	public
	PropertyJServ( String url, String user, String pass )
		{
		super( url, user, pass );
		}

	public BRATProperty
	getProperty( String key )
		throws DBIException
		{
		BRATProperty result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_PROPERTY );

			request.setParameter
				( JSRVConstants.P_PROPERTY_KEY, key );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (BRATProperty)
					response.getResult
						( JSRVConstants.P_PROPERTY );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Hashtable
	getAllProperties()
		throws DBIException
		{
		Hashtable result = new Hashtable();

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_ALLPROPERTIES );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Hashtable)
					response.getResult
						( JSRVConstants.P_PROPERTY_HASHTABLE );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public void
	commit( BRATProperty bp )
		throws DBIException
		{
		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "CommitLevelParam" + this.requestCounter,
						JSRVConstants.REQ_COMMIT_PROPERTY );

			request.setParameter
				( JSRVConstants.P_PROPERTY, bp );

			JSRVConnection conn =
				new JSRVConnection( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				{
				bp.setModified( false );
				bp.setInDatabase( true );
				}
			else
				{
				throw new JSRVException
					( "commit BRAT property failed err="
						+ response.getErrorCode()
						+ " '" + response.getErrorMessage() + "'" );
				}
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "JServlet error: " + ex.getMessage() );
			}
		}

	}

