
package org.gjt.bugrat.dbi;

import java.util.Vector;
import java.util.Hashtable;

import org.gjt.bugrat.db.*;
import org.gjt.bugrat.servlet.*;


public class
ReportJServ extends BugRatJServ
	implements ReportDBI
	{
	public
	ReportJServ( String url, String user, String pass )
		{
		super( url, user, pass );
		}

	public Report
	getNewReport()
		throws DBIException
		{
		throw new DBIException( "--UNIMPLEMENTED--" );
		}

	public Report
	getReport( int reportId )
		throws DBIException
		{
		Report result = null;

		System.err.println( "ReportJServ.getReport " + reportId );

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "Jart" + this.requestCounter,
						JSRVConstants.REQ_GET_REPORT );

			request.setParameter
				( JSRVConstants.P_REPORT_ID, new Integer(reportId) );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Report)
					response.getResult
						( JSRVConstants.P_REPORT );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "Jart Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public Vector
	matchReports( String selectStr )
		throws DBIException
		{
		Vector result = null;

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "ReportMatch" + this.requestCounter,
						JSRVConstants.REQ_MATCH_REPORTS );

			request.setParameter
				( JSRVConstants.P_MATCH_EXPR, selectStr );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response =
				conn.performRequest( request );

			if ( response.getSuccess() )
				result = (Vector)
					response.getResult
						( JSRVConstants.P_REPORT_VECTOR );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRat Servlet error: " + ex.getMessage() );
			}

		return result;
		}

	public void
	commit( Report rep )
		throws DBIException
		{
		throw new DBIException( "--UNIMPLEMENTED--" );
		}

	/**
	*
	* linkReport - this links a report to a bug
	*
	**/

	public void
	linkReport( int reportId, int bugId )
		throws DBIException
		{
		int result = bugId;
		Integer repIdInt = new Integer( reportId );
		Integer bugIdInt = new Integer( bugId );

		try {
			this.requestCounter++;

			JSRVRequest request =
				new JSRVRequest
					( "LinkReport" + this.requestCounter,
						JSRVConstants.REQ_LINK_REPORT );

			request.setParameter
				( JSRVConstants.P_REPORT_ID, repIdInt );
			request.setParameter
				( JSRVConstants.P_BUG_ID, bugIdInt );

			JSRVConnection conn =
				new JSRVConnection
					( this.url, this.user, this.pass );

			JSRVResponse response = 
				conn.performRequest( request );

			if ( ! response.getSuccess() )
				throw new DBIException
					( "link failed, " + response.getErrorMessage() );
			}
		catch ( JSRVException ex )
			{
			throw new DBIException
				( "BugRat Servlet error: " + ex.getMessage() );
			}
		}

	public boolean
	isReportLinkedToBug( int repId, int bugId )
		throws DBIException
		{
		throw new DBIException( "--UNIMPLEMENTED--" );
		}

	}
