
package org.gjt.bugrat.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public
class		BugRatRequest
	{
	private BugRatServlet			servlet = null;
	private HttpServletRequest		servletRequest = null;
	private HttpServletResponse		servletResponse = null;
	private String					pathInfo = null;
	private boolean					isAdmin = false;


	public
	BugRatRequest(
			HttpServletRequest req,
			HttpServletResponse resp,
			BugRatServlet servlet )
		{
		this.servlet = servlet;
		this.servletRequest = req;
		this.servletResponse = resp;
		this.pathInfo = req.getPathInfo();
		}

	public boolean
	isAdmin()
		{
		return this.servlet.isAdmin();
		}

	public boolean
	allowsReportComments()
		{
		return this.servlet.allowsReportComments();
		}

	public boolean
	allowsBugComments()
		{
		return this.servlet.allowsBugComments();
		}

	public boolean
	getCommentsRequireAdmin()
		{
		return this.servlet.getCommentsRequireAdmin();
		}

	public boolean
	getNewUserRequiresAdmin()
		{
		return this.servlet.getNewUserRequiresAdmin();
		}

	public BugRatServlet
	getServlet()
		{
		return this.servlet;
		}

	public HttpServletRequest
	getRequest()
		{
		return this.servletRequest;
		}

	public HttpServletResponse
	getResponse()
		{
		return this.servletResponse;
		}

	public String
	getPathInfo()
		{
		return this.pathInfo;
		}

	/**
	 * This returns the path needed to reference this servlet.
	 * NOTE that we have eliminated support for pre-2.2 API's.
	 *      It would be possible, however, to make this work
	 *      with pre-2.2 APIs simply by eliminating the call
	 *      to the getContextPath(). This is why we force the
	 *      servlets to use this method, and NOT the method
	 *      provided by HttpServletRequest.
	 */
	public String
	getServletPath()
		{
		return
			this.servletRequest.getContextPath()
				+ this.servletRequest.getServletPath();
		}

	/**
	 * This returns the servlet path up to the name of the
	 * servlet. This is a bit of a hack. We have three servlets
	 * that reference eachother, which requires that we be able
	 * to build Urls for hrefs. Typically, we might be able to
	 * use the getContextPath() along with the servlet name, but
	 * this would assume that the administrator did not use a
	 * subpath to the servlet for some reason. Thus, we will
	 * use the simple algorithm of splicing off the servlet
	 * name to leave the url prefixing it.
	 */
	public String
	getServletContext()
		{
		String path = this.getServletPath();
		int index = path.lastIndexOf( "/" );
		if ( index != -1 )
			path = path.substring( 0, index );
		return path;
		}

	public String
	getServletUrlPrefix()
		{
		StringBuffer buf = new StringBuffer();

		buf.append( this.servletRequest.getScheme() );
		buf.append( "://" );
		buf.append( this.servletRequest.getServerName() );
		if ( this.servletRequest.getServerPort() != 80 )
			{
			buf.append( ":" );
			buf.append( this.servletRequest.getServerPort() );
			}

		return buf.toString();
		}

	public String
	getAdminServletName()
		{
		return this.servlet.getAdminServletName();
		}

	public String
	getAdminServletPath()
		{
		return
			this.getServletContext() + "/"
				+ this.servlet.getAdminServletName();
		}

	public String
	getReportServletName()
		{
		return this.servlet.getReportServletName();
		}

	public String
	getReportServletPath()
		{
		return
			this.getServletContext() + "/"
				+ this.servlet.getReportServletName();
		}

	public String
	getViewerServletName()
		{
		return this.servlet.getViewerServletName();
		}

	public String
	getViewerServletPath()
		{
		return
			this.getServletContext() + "/"
				+ this.servlet.getViewerServletName();
		}

	String[]
	getParameterValues( String name )
		{
		return this.getRequest().getParameterValues( name );
		}

	public PrintWriter
	getHTMLWriter()
		throws IOException
		{
		this.getResponse().setContentType( "text/html" );
		return this.getResponse().getWriter();
		}

	}

