
package org.gjt.bugrat.servlet;

import java.io.*;
import java.util.*;
import java.text.FieldPosition;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;

import javax.servlet.*;
import javax.servlet.http.*;

import org.gjt.bugrat.db.*;
import org.gjt.bugrat.dbi.*;


public
class		BugRatViewer
extends		BugRatServlet 
	{
	public String
	getServletInfo()
		{
		return "BugRat - Viewer servlet, version "
				+ this.getVersionStr() + " by Tim Endres.";
		}

	public void
	init( ServletConfig config )
		throws ServletException
		{
		super.init( config );
		}

	public void
	doGet( HttpServletRequest req, HttpServletResponse res )
		throws ServletException, IOException
		{
		BugRatRequest bReq = new BugRatRequest( req, res, this );

		String pathInfo = bReq.getPathInfo();

		if ( this.commonGet( bReq ) )
			{
			// Handled by the common GET code...
			}
		else if ( pathInfo == null || pathInfo.equals( "/" ) )
			{
			// UNDONE - Main Menu?
			this.sendIndexPage( bReq );
			}
		else if ( pathInfo.equalsIgnoreCase( "/index" ) ||
					pathInfo.equalsIgnoreCase( "/index.html" ) )
			{
			this.sendIndexPage( bReq );
			}
		else
			{
			PrintWriter cW = bReq.getHTMLWriter();
			this.sendCommonHeader( bReq, cW, "BugRat - Error Unknown Command" );
			this.reportError( bReq, cW,
				"Servlet request (via pathinfo) not recognized." );
			this.sendCommonTrailer( bReq, cW );
			cW.close();
			}
		}

	/**
	 * Write survey results to output file in response to the POSTed
	 * form.  Write a "thank you" to the client.     
	 */
	public void
	doPost( HttpServletRequest req, HttpServletResponse res )
		throws ServletException, IOException
		{
		BugRatRequest bReq = new BugRatRequest( req, res, this );

		String pathInfo = bReq.getPathInfo();

		if ( this.commonPost( bReq ) )
			{
			// Handled by the common GET code...
			}
		else if ( pathInfo == null )
			{
			this.processShowReports( bReq );
			}
		else
			{
			PrintWriter cW = bReq.getHTMLWriter();
			this.sendCommonHeader
				( bReq, cW, "BugRat - Error Unknown Command" );
			this.reportError( bReq, cW,
				"Servlet request (via pathinfo) not recognized." );
			this.sendCommonTrailer( bReq, cW );
			cW.close();
			}
		}

	private void
	sendIndexPage( BugRatRequest bReq )
		throws IOException
		{
		PrintWriter cW = bReq.getHTMLWriter();
		this.sendCommonHeader( bReq, cW, "BugRat - Viewer Servlet" );

		this.sendPropertyHTML( bReq, cW, "viewServlet.indexHtml" );

		this.sendCommonTrailer( bReq, cW );
		cW.close();
		}

	}

