
package org.gjt.bugrat.servlet;

import java.io.*;
import java.util.Hashtable;


public class
JSRVResponse extends Object
	implements Serializable
	{
	int			apiVersion;

	String		requestId;

	boolean		success;

	int			errorCode;
	String		errorMsg;
	String		exception;

	Hashtable	results;


	public
	JSRVResponse( String reqId )
		{
		this.success = false;
		this.requestId = null;
		this.errorCode = 0;
		this.errorMsg = null;
		this.exception = null;
		this.results = new Hashtable();
		}

	public
	JSRVResponse( String reqId, int errorCode, String errorMsg )
		{
		this.success = false;
		this.requestId = reqId;
		this.errorCode = errorCode;
		this.errorMsg = errorMsg;
		this.exception = null;
		this.results = new Hashtable();
		}

	public
	JSRVResponse( String reqId, Object result )
		{
		this.success = true;
		this.requestId = reqId;
		this.errorCode = 0;
		this.errorMsg = null;
		this.exception = null;
		this.results = new Hashtable();
		}

	public String
	getRequestId()
		{
		return this.requestId;
		}

	public boolean
	getSuccess()
		{
		return this.success;
		}

	public void
	setSuccess( boolean success )
		{
		this.success = success;
		}

	public int
	getErrorCode()
		{
		return this.errorCode;
		}

	public void
	setErrorCode( int code )
		{
		this.errorCode = code;
		}

	public String
	getErrorMessage()
		{
		return this.errorMsg;
		}

	public void
	setErrorMessage( String msg )
		{
		this.errorMsg = msg;
		}

	public String
	getException()
		{
		return this.exception;
		}

	public void
	setException( Exception exception )
		{
		StringWriter strW = new StringWriter();
		PrintWriter exW = new PrintWriter( strW );
		exception.printStackTrace( exW );
		this.exception = strW.toString();
		}

	public String
	getErrorReport()
		{
		return
			"ErrorCode = " + this.getErrorCode() + "\n" +
			"ErrorMessage = " + this.getErrorMessage() + "\n" +
			this.getException();
		}

	public Object
	getResult( String name )
		{
		return this.results.get( name );
		}

	public void
	setResult( String name, Object result )
		{
		if ( result != null )
			this.results.put( name, result );
		}

	}

