
#
# Establish the default entries in the 'configuration' tables.
#

#
# CLASSES
#
INSERT INTO class ( id, lvl, name, info )
	VALUES ( 'B', 0, 'swbug', 'Software Bug' );

INSERT INTO class ( id, lvl, name, info )
	VALUES ( 'D', 0, 'docbug', 'Documentation Bug' );

INSERT INTO class ( id, lvl, name, info )
	VALUES ( 'W', 0, 'webbug', 'WebSite Bug' );

INSERT INTO class ( id, lvl, name, info )
	VALUES ( 'Q', 0, 'support', 'Support Question' );

INSERT INTO class ( id, lvl, name, info )
	VALUES ( 'F', 0, 'feature', 'Feature Request' );

#
# SEVERITIES
#

INSERT INTO severity ( id, lvl, name, info )
	VALUES ( 'C', 5, 'critical',
			'Critical bug that makes program unusable.' );

INSERT INTO severity ( id, lvl, name, info )
	VALUES ( 'S', 3, 'serious',
			'Serious bug that prevents release.' );

INSERT INTO severity ( id, lvl, name, info )
	VALUES ( 'N', 2, 'non-critical',
			'Non-critical bug, can be released.' );

INSERT INTO severity ( id, lvl, name, info )
	VALUES ( 'K', 1, 'cosmetic',
			'Costmetic bug, can be released.' );


#
# STATES
#

INSERT INTO state ( id, lvl, name, info )
	VALUES ( 'R', 0, 'received',
			'Report received but unassigned.' );

INSERT INTO state ( id, lvl, name, info )
	VALUES ( 'O', 1, 'open',
			'Report has been assigned and is being analyzed.' );

INSERT INTO state ( id, lvl, name, info )
	VALUES ( 'A', 2, 'analyzed',
			'Report has been analyzed and is being processed.' );

INSERT INTO state ( id, lvl, name, info )
	VALUES ( 'F', 3, 'fixed',
			'Report has been fixed or explained.' );

INSERT INTO state ( id, lvl, name, info )
	VALUES ( 'C', 4, 'closed',
			'Report has been closed.' );

INSERT INTO state ( id, lvl, name, info )
	VALUES ( 'H', 5, 'suspended',
			'Report has been deferred until a later time.' );


#
# PRIORITIES
#

INSERT INTO priority ( id, lvl, name, info )
	VALUES ( 'H', 3, 'high',
			'The highest priority.' );

INSERT INTO priority ( id, lvl, name, info )
	VALUES ( 'M', 2, 'medium',
			'Needs to be completed before release.' );

INSERT INTO priority ( id, lvl, name, info )
	VALUES ( 'L', 1, 'low',
			'Can be implemented in a future release.' );


#
# CONFIDENCE LEVELS
#

INSERT INTO confidence ( id, lvl, name, info )
	VALUES ( 'C', 5, 'confidential',
			'Not for external viewing.' );

INSERT INTO confidence ( id, lvl, name, info )
	VALUES ( 'N', 3, 'nda',
			'Viewable only by those under Non-Disclosure.' );

INSERT INTO confidence ( id, lvl, name, info )
	VALUES ( 'P', 1, 'public',
			'Can be viewed by the public.' );

