

DROP TABLE ACTIONTYPE CASCADE CONSTRAINTS ; 

CREATE TABLE ACTIONTYPE ( 
  ID        CHAR (1)      NOT NULL, 
  NAME      VARCHAR2 (32)  NOT NULL, 
  DESCTEXT  VARCHAR2 (255)  NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE AUTHGROUP CASCADE CONSTRAINTS ; 

CREATE TABLE AUTHGROUP ( 
  USERID   RAW (16)      NOT NULL, 
  GROUPID  RAW (16)      NOT NULL, 
  CONSTRAINT PK_AUTHGROUP
  PRIMARY KEY ( USERID, GROUPID ) ) ; 


DROP TABLE AUTHUSER CASCADE CONSTRAINTS ; 

CREATE TABLE AUTHUSER ( 
  USERID  RAW (16)      NOT NULL, 
  PASSWD  RAW (16), 
  PRIMARY KEY ( USERID ) ) ; 


DROP TABLE BUG CASCADE CONSTRAINTS ; 

CREATE TABLE BUG ( 
  ID           NUMBER (10)   NOT NULL, 
  SOURCE       CHAR (1), 
  SRCID        NUMBER (10), 
  RESPONSIBLE  NUMBER (10), 
  OPENED       DATE, 
  CLOSED       DATE, 
  CONFIDENCE   CHAR (1), 
  SEVERITY     CHAR (1), 
  PRIORITY     CHAR (1), 
  STATE        CHAR (1), 
  CLASS        CHAR (1), 
  PROJECT      VARCHAR2 (10), 
  CATEGORY     VARCHAR2 (10), 
  SUBCAT       VARCHAR2 (10), 
  BUGDESC      NUMBER (10), 
  ENVDESC      NUMBER (10), 
  REPRO        NUMBER (10), 
  AROUND       NUMBER (10), 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE CATEGORY CASCADE CONSTRAINTS ; 

CREATE TABLE CATEGORY ( 
  PKG      VARCHAR2 (10)  NOT NULL, 
  CAT      VARCHAR2 (10)  NOT NULL, 
  SUB      VARCHAR2 (10)  NOT NULL, 
  NAME     VARCHAR2 (32)  NOT NULL, 
  RESP     NUMBER (10), 
  CATDESC  VARCHAR2 (512), 
  CONSTRAINT PK_CATEGORY
  PRIMARY KEY ( PKG, CAT, SUB ) ) ; 


DROP TABLE CLASS CASCADE CONSTRAINTS ; 

CREATE TABLE CLASS ( 
  ID    CHAR (1)      NOT NULL, 
  NAME  VARCHAR2 (32)  NOT NULL, 
  INFO  VARCHAR2 (255), 
  LVL   NUMBER (10)   NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE CONFIDENCE CASCADE CONSTRAINTS ; 

CREATE TABLE CONFIDENCE ( 
  ID    CHAR (1)      NOT NULL, 
  NAME  VARCHAR2 (32)  NOT NULL, 
  INFO  VARCHAR2 (255), 
  LVL   NUMBER (10)   NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE DESCRIPTION CASCADE CONSTRAINTS ; 

CREATE TABLE DESCRIPTION ( 
  ID        NUMBER (10)   NOT NULL, 
  SYNOPSIS  VARCHAR2 (255), 
  URL       VARCHAR2 (255), 
  EMAIL     NUMBER (10), 
  MIMETYPE  VARCHAR2 (128), 
  DESCTEXT  CLOB, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE EMAIL CASCADE CONSTRAINTS ; 

CREATE TABLE EMAIL ( 
  ID          NUMBER (10)   NOT NULL, 
  RECVDATE    DATE          NOT NULL, 
  HDRMSGID    VARCHAR2 (255)  NOT NULL, 
  HDRFROM     VARCHAR2 (255)  NOT NULL, 
  HDRTO       VARCHAR2 (255)  NOT NULL, 
  HDRSUBJECT  VARCHAR2 (255), 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE EMAILCONTENT CASCADE CONSTRAINTS ; 

CREATE TABLE EMAILCONTENT ( 
  ID       NUMBER (10)   NOT NULL, 
  "size"   NUMBER (10)   NOT NULL, 
  CONTENT  BLOB          NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE ENVDEFS CASCADE CONSTRAINTS ; 

CREATE TABLE ENVDEFS ( 
  ID        VARCHAR2 (8)  NOT NULL, 
  OS        VARCHAR2 (32)  NOT NULL, 
  OSREL     VARCHAR2 (32)  NOT NULL, 
  PLATFORM  VARCHAR2 (32)  NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE ENVDESC CASCADE CONSTRAINTS ; 

CREATE TABLE ENVDESC ( 
  ID        NUMBER (10)   NOT NULL, 
  RELEASE   VARCHAR2 (32), 
  ENVJVM    VARCHAR2 (32), 
  ENVOS     VARCHAR2 (32), 
  ENVOSREL  VARCHAR2 (32), 
  ENVPLAT   VARCHAR2 (32), 
  ENVDESC   VARCHAR2 (255), 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE FORWARD CASCADE CONSTRAINTS ; 

CREATE TABLE FORWARD ( 
  ID       NUMBER (10)   NOT NULL, 
  SOURCE   CHAR (1)      NOT NULL, 
  SRCID    NUMBER (10)   NOT NULL, 
  SRCSUB   NUMBER (10)   NOT NULL, 
  DESTURL  VARCHAR2 (255)  NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE PERSON CASCADE CONSTRAINTS ; 

CREATE TABLE PERSON ( 
  ID     NUMBER (10)   NOT NULL, 
  TYPE   CHAR (1)      NOT NULL, 
  EMAIL  VARCHAR2 (128)  NOT NULL, 
  NAME   VARCHAR2 (128)  NOT NULL, 
  LOGIN  VARCHAR2 (16), 
  ORG    VARCHAR2 (128), 
  URL    VARCHAR2 (255), 
  PHONE  VARCHAR2 (32), 
  FAX    VARCHAR2 (32), 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE PRIORITY CASCADE CONSTRAINTS ; 

CREATE TABLE PRIORITY ( 
  ID    CHAR (1)      NOT NULL, 
  NAME  VARCHAR2 (32)  NOT NULL, 
  INFO  VARCHAR2 (255), 
  LVL   NUMBER (38)   NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE PROPERTIES CASCADE CONSTRAINTS ; 

CREATE TABLE PROPERTIES ( 
  PROPKEY  VARCHAR2 (128)  NOT NULL, 
  PROPVAL  CLOB, 
  PRIMARY KEY ( PROPKEY ) ) ; 


DROP TABLE RATACTION CASCADE CONSTRAINTS ; 

CREATE TABLE RATACTION ( 
  ID        NUMBER (10)   NOT NULL, 
  ACTTYPE   CHAR (1)      , 
  ACTOR     NUMBER (10)   , 
  ACTTIME   DATE          , 
  TARGET    CHAR (1)      , 
  TARGETID  NUMBER (10)   , 
  ARGONE    NUMBER (10)   , 
  ARGTWO    NUMBER (10)   , 
  ACTCMT    VARCHAR2 (255), 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE RATCOMMENT CASCADE CONSTRAINTS ; 

CREATE TABLE RATCOMMENT ( 
  ID         NUMBER (10)   NOT NULL, 
  TARGET     CHAR (1)      NOT NULL, 
  TARGETID   NUMBER (10)   NOT NULL, 
  DESCID     NUMBER (10)   NOT NULL, 
  COMMENTOR  NUMBER (10)   NOT NULL, 
  CMTTIME    DATE          NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE REPBUG CASCADE CONSTRAINTS ; 

CREATE TABLE REPBUG ( 
  REPORT  NUMBER (10)   NOT NULL, 
  BUG     NUMBER (10)   NOT NULL, 
  CONSTRAINT PK_REPBUG
  PRIMARY KEY ( REPORT, BUG ) ) ; 


DROP TABLE REPORT CASCADE CONSTRAINTS ; 

CREATE TABLE REPORT ( 
  ID           NUMBER (10)   NOT NULL, 
  SOURCE       CHAR (1), 
  SRCID        NUMBER (10), 
  SUBMITTED    DATE, 
  SUBMITTER    NUMBER (10), 
  RESPONSIBLE  NUMBER (10), 
  CONFIDENCE   CHAR (1), 
  SEVERITY     CHAR (1), 
  PRIORITY     CHAR (1), 
  STATE        CHAR (1), 
  CLASS        CHAR (1), 
  PROJECT      VARCHAR2 (10), 
  CATEGORY     VARCHAR2 (10), 
  SUBCAT       VARCHAR2 (10), 
  REPDESC      NUMBER (10), 
  ENVDESC      NUMBER (10), 
  REPRO        NUMBER (10), 
  AROUND       NUMBER (10), 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE SEQUENCE CASCADE CONSTRAINTS ; 

CREATE TABLE SEQUENCE (
  NAME      CHAR (64)     NOT NULL,
  NEXTSEQ   NUMBER (10)   NOT NULL,
  PRIMARY KEY ( name ) );


DROP TABLE SEVERITY CASCADE CONSTRAINTS ; 

CREATE TABLE SEVERITY ( 
  ID    CHAR (1)      NOT NULL, 
  NAME  VARCHAR2 (32)  NOT NULL, 
  INFO  VARCHAR2 (255), 
  LVL   NUMBER (10)   NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE STATE CASCADE CONSTRAINTS ; 

CREATE TABLE STATE ( 
  ID    CHAR (1)      NOT NULL, 
  NAME  CHAR (32)     NOT NULL, 
  INFO  CHAR (255), 
  LVL   NUMBER (38)   NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE SUBSCRIBE CASCADE CONSTRAINTS ; 

CREATE TABLE SUBSCRIBE ( 
  ID          NUMBER (10)   NOT NULL, 
  SUBTYPE     CHAR (1)      NOT NULL, 
  PROJECT     CHAR (8), 
  CATEGORY    CHAR (8), 
  SUBCAT      CHAR (8), 
  TARGET      CHAR (1)      NOT NULL, 
  TARGETID    NUMBER (10)   NOT NULL, 
  SUBSCRIBER  NUMBER (10)   NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 


DROP TABLE SUBTYPE CASCADE CONSTRAINTS ; 

CREATE TABLE subtype ( 
  ID        CHAR (1)      NOT NULL, 
  NAME      CHAR (32)     NOT NULL, 
  DESCTEXT  CHAR (255)    NOT NULL, 
  PRIMARY KEY ( ID ) ) ; 

